#include <iostream>
#include <cstdio>
#include <cstring>
#include <vector>
#include <queue>

using namespace std;

// par de inteiros: guarda o vertice v e o peso da aresta
typedef pair<int,int> ii;

// todos os vertices v adjacentes a u 
typedef vector<ii> vii;

// lista de adjacencia para todo vertice u do meu grafo..
vector<vii> AdjList(200);

typedef vector<int> vi;

//#define VISITADO 1
//#define NAOVISITADO 0
#define INF 10000000

vi d; // vetor de distancia....

void printAdjList(int nv){
	for (int u = 0; u < nv; ++u){ // para todo vertice u
		printf("%d -> ", u);
		for (int i = 0; i < AdjList[u].size(); ++i) { // para todo adjacente v de u
			ii v = AdjList[u][i];
			printf("(%d, %d) -> ", v.first, v.second);
		}
		printf("\n");
	}
}

void bfs(int u, int nv){
	queue<int> q;

	//vi d(nv,INF);
	d.assign(nv, INF);
	d[u] = 0; // a distancia de u para u eh zero.
	q.push(u); 

	while(!q.empty()){
		int k = q.front(); q.pop();
		printf("%d ", k+1);

		for (int i = 0; i < AdjList[k].size(); ++i) { // para todo adjacente v de u
			ii v = AdjList[k][i];
			if (d[v.first] == INF){
				d[v.first] = d[k] + 1;  // o nivel do adj v eh o do pai k + 1
				q.push(v.first);  // coloca o adj na fila...
			}
		}
	}

}


int main(int argc, char const *argv[])
{
	int A, V, s,t;

	cin >> A; 
	cin >> V;
	cin >> s;
	cin >> t;

	int u,v,w;

	for (int i = 0; i < A; ++i){
		cin >> u >> v >> w;
		AdjList[u].push_back(make_pair(v, 0));
		AdjList[v].push_back(make_pair(u, 0));
	}

	printAdjList(V);

	bfs(0, V); printf("\n");
	printf("A distancia de %d para os demais vertices eh\n", s);
	for (int i = 0; i < V; ++i){
		printf("d[%d] = %d\n", i, d[i]);
	}

	return 0;
}

